local DenidilUltimate = {}

DenidilUltimate.name = "Denidil's Ultimate Counter"

local DUC_TLW

local function DUC_UpdatePowerDisplay()

   if IsSlotUsed(8) then
        DUC_TLW:SetHidden(false)
    else
        DUC_TLW:SetHidden(true)
        return
    end

    local UltimatePoints = GetUnitPower("player", POWERTYPE_ULTIMATE)
    local abilityCost = GetSlotAbilityCost(8)
    DUC_TLW.label:SetText(UltimatePoints .. "/" .. abilityCost)
	
end

function DenidilUltimate:Initialize()

    -- Windows/Label setup
    DUC_TLW = WINDOW_MANAGER:CreateTopLevelWindow("DenidilUltimate")
    DUC_TLW:SetParent(ZO_ActionBar1)
    DUC_TLW:SetDimensions(100, 20)
    DUC_TLW:SetAnchor(BOTTOM, ActionButton8, TOP, 0, 0)
    DUC_TLW:SetHidden(false)
    DUC_TLW:SetScale(0.9)
    DUC_TLW:SetAlpha(1.0)
    DUC_TLW:SetClampedToScreen(true)

    DUC_TLW.label = WINDOW_MANAGER:CreateControl("DenidilUltimate_Label", DUC_TLW, CT_LABEL)
    DUC_TLW.label:SetAnchor(CENTER, DUC_TLW, CENTER, 0, 0)
    DUC_TLW.label:SetText("---/---")
    DUC_TLW.label:SetColor(1, 1, 1, 1)
    DUC_TLW.label:SetFont("ZoFontChat")

    -- set the initial value
    local cur, _, _ = GetUnitPower("player", POWERTYPE_ULTIMATE)
    DUC_UpdatePowerDisplay(cur)

    EVENT_MANAGER:RegisterForEvent(DenidilUltimate.name, EVENT_POWER_UPDATE, DUC_UpdatePowerDisplay)
    EVENT_MANAGER:AddFilterForEvent(DenidilUltimate.name, EVENT_POWER_UPDATE, REGISTER_FILTER_POWER_TYPE, POWERTYPE_ULTIMATE, REGISTER_FILTER_UNIT_TAG, "player")
    EVENT_MANAGER:RegisterForEvent(DenidilUltimate.name, EVENT_ACTIVE_WEAPON_PAIR_CHANGED, DUC_UpdatePowerDisplay)

    self.isLoaded = true   
	
end

local function DUC_OnAddOnLoaded(event, addonName)

  if addonName == DenidilUltimate.name or addonName == "DenidilUltimate" then
    DenidilUltimate:Initialize()
  end
  
end

EVENT_MANAGER:RegisterForEvent(DenidilUltimate.name, EVENT_ADD_ON_LOADED, DUC_OnAddOnLoaded)

--[[
-- for debug if EVENT_ADD_ON_LOADED fails to init the addon
local function DUC_OnPlayerActivated(event)
    if not DenidilUltimate.isLoaded then
        d("Denidil's Ultimate Counter: Our OnAddOnLoaded trigger didn't successfully load the addon, attempting late Initialization.  This is a bug and should be filed.")
        DenidilUltimate:Initialize()
    end
end

EVENT_MANAGER:RegisterForEvent(DenidilUltimate.name, EVENT_PLAYER_ACTIVATED, DUC_OnPlayerActivated)
--]]